OSDN Git Service

Avoid problems with relative $(srcdir) when installing syslimits.h.
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
index 7381b3f..7cea719 100755 (executable)
@@ -5,25 +5,41 @@
 
 # See README-fixinc for more information.
 
+# Directory where gcc sources (and sometimes special include files) live.
+# fixincludes doesn't use this, but fixinc.svr4 does, and I want to make
+# sure somebody doesn't try to use arg3 for something incompatible. -- gumby
+SRCDIR=${3-${SRCDIR-.}}
+
 # Directory containing the original header files.
 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
 INPUT=${2-${INPUT-/usr/include}}
 
-# This prevents /bin/ex from failing if the current terminal type is
-# unrecognizable.
-TERM=unknown
-export TERM
-
 # Directory in which to store the results.
-LIB=${1-${LIB-/usr/local/lib/gcc-include}}
+LIB=${1?"fixincludes: output directory not specified"}
+
+# Define PWDCMD as a command to use to get the working dir
+# in the form that we want.
+PWDCMD=pwd
+case "`pwd`" in
+//*)
+       # On an Apollo, discard everything before `/usr'.
+       PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
+       ;;
+esac
 
 # Make sure it exists.
 if [ ! -d $LIB ]; then
   mkdir $LIB || exit 1
 fi
 
-# Make LIB absolute.
-cd $LIB; LIB=`pwd`
+# Make LIB absolute only if needed to avoid problems with the amd.
+case $LIB in
+/*)
+       ;;
+*)
+       cd $LIB; LIB=`${PWDCMD}`
+       ;;
+esac
 
 # Fail if no arg to specify a directory for the output.
 if [ x$1 = x ]
@@ -31,7 +47,7 @@ then echo fixincludes: no output directory specified
 exit 1
 fi
 
-echo 'Building fixincludes in ' ${LIB}
+echo Building fixed headers in ${LIB}
 
 # Determine whether this system has symbolic links.
 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
@@ -41,17 +57,65 @@ else
   LINKS=false
 fi
 
-echo 'Making directories:'
+echo Finding directories and links to directories
 cd ${INPUT}
 # Find all directories and all symlinks that point to directories.
-files=`        find . -type d -print | sed '/^.$/d'
-       $LINKS && find . -type l -exec test -d '{}' \; -print`
+# Put the list in $files.
+# Each time we find a symlink, add it to newdirs
+# so that we do another find within the dir the link points to.
+# Note that $files may have duplicates in it;
+# later parts of this file are supposed to ignore them.
+dirs="."
+levels=2
+while [ -n "$dirs" ] && [ $levels -gt 0 ]
+do
+    levels=`expr $levels - 1`
+    newdirs=
+    for d in $dirs
+    do
+       echo " Searching $INPUT/$d"
+       if [ "$d" != . ]
+       then
+           d=$d/.
+       fi
+
+       # Find all directories under $d, relative to $d, excluding $d itself.
+        files="$files `find $d -type d -print | \
+                      sed -e '/\/\.$/d' -e '/^\.$/d'`"
+       # Find all links to directories.
+       # Using `-exec test -d' in find fails on some systems,
+       # and trying to run test via sh fails on others,
+       # so this is the simplest alternative left.
+       # First find all the links, then test each one.
+       theselinks=
+       $LINKS && \
+         theselinks=`find $d -type l -print`
+       for d1 in $theselinks --dummy--
+       do
+           # If the link points to a directory,
+           # add that dir to $newdirs
+           if [ -d $d1 ]
+           then
+               newdirs="$newdirs $d1"
+           fi
+       done
+    done
+
+    files="$files $newdirs"
+    dirs="$newdirs"
+done
+
+dirs=
+echo "All directories (including links to directories):"
+echo $files
+
 for file in $files; do
   rm -rf $LIB/$file
   if [ ! -d $LIB/$file ]
   then mkdir $LIB/$file
   fi
 done
+mkdir $LIB/root
 
 # treetops gets an alternating list
 # of old directories to copy
@@ -59,11 +123,11 @@ done
 treetops="${INPUT} ${LIB}"
 
 if $LINKS; then
-  echo 'Making internal symbolic directory links'
+  echo 'Making symbolic directory links'
   for file in $files; do
     dest=`ls -ld $file | sed -n 's/.*-> //p'`
     if [ "$dest" ]; then    
-      cwd=`pwd`
+      cwd=`${PWDCMD}`
       # In case $dest is relative, get to $file's dir first.
       cd ${INPUT}
       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
@@ -73,22 +137,60 @@ if $LINKS; then
       if [ $? = 0 ]; then
        cd $dest
        # X gets the dir that the link actually leads to.
-       x=`pwd`
+       x=`${PWDCMD}`
+       # If a link points to ., make a similar link to .
+       if [ $x = $INPUT ]; then
+         echo $file '->' . ': Making link'
+         rm -fr ${LIB}/$file > /dev/null 2>&1
+         ln -s . ${LIB}/$file > /dev/null 2>&1
        # If link leads back into ${INPUT},
        # make a similar link here.
-       if expr $x : "${INPUT}/.*" > /dev/null; then
+       elif expr $x : "${INPUT}/.*" > /dev/null; then
          # Y gets the actual target dir name, relative to ${INPUT}.
          y=`echo $x | sed -n "s&${INPUT}/&&p"`
          echo $file '->' $y ': Making link'
          rm -fr ${LIB}/$file > /dev/null 2>&1
          ln -s ${LIB}/$y ${LIB}/$file > /dev/null 2>&1
        else
-         # If the link is to outside ${INPUT},
+         # If the link is to a dir $target outside ${INPUT},
+         # repoint the link at ${INPUT}/root$target
+         # and process $target into ${INPUT}/root$target
          # treat this directory as if it actually contained the files.
-# This line used to have $dest instead of $x.
-# $dest seemed to be wrong for links found in subdirectories
-# of ${INPUT}.  Does this change break anything?
-         treetops="$treetops $x ${LIB}/$file"
+         echo $file '->' root$x ': Making link'
+         if [ -d $LIB/root$x ]
+         then true
+         else
+           dirname=root$x/
+           dirmade=.
+           cd $LIB
+           while [ x$dirname != x ]; do
+             component=`echo $dirname | sed -e 's|/.*$||'`
+             mkdir $component >/dev/null 2>&1
+             cd $component
+             dirmade=$dirmade/$component
+             dirname=`echo $dirname | sed -e 's|[^/]*/||'`
+           done
+         fi
+         # Duplicate directory structure created in ${LIB}/$file in new
+         # root area.
+         for file2 in $files; do
+           case $file2 in
+             $file/.*)
+               ;;
+             *)
+               dupdir=${LIB}/root$x/`echo $file2 | sed -n "s|^${file}/||p"`
+               echo "Duplicating ${file}'s ${dupdir}"
+               if [ -d ${dupdir} ]
+               then true
+               else
+                 mkdir ${dupdir}
+               fi
+               ;;
+           esac
+          done
+         rm -fr ${LIB}/$file > /dev/null 2>&1
+         ln -s ${LIB}/root$x ${LIB}/$file > /dev/null 2>&1
+         treetops="$treetops $x ${LIB}/root$x"
        fi
       fi
       cd $cwd
@@ -99,11 +201,25 @@ fi
 set - $treetops
 while [ $# != 0 ]; do
   # $1 is an old directory to copy, and $2 is the new directory to copy to.
-  echo "Finding header files in $1:"
   cd ${INPUT}
   cd $1
-  files=`find . -name '*.h' -type f -print`
-  echo 'Checking header files:'
+# The same dir can appear more than once in treetops.
+# There's no need to scan it more than once.
+  if [ -f $2/DONE ]
+  then
+    files=
+  else
+    touch $2/DONE
+    echo Fixing directory $1 into $2
+# Check .h files which are symlinks as well as those which are files.
+# A link to a header file will not be processed by anything but this.
+    if $LINKS; then
+      files=`find . -name '*.h' \( -type f -o -type l \) -print`
+    else
+      files=`find . -name '*.h' -type f -print`
+    fi
+    echo Checking header files
+  fi
 # Note that BSD43_* are used on recent MIPS systems.
   for file in $files; do
 # This call to egrep is essential, since checking a file with egrep
@@ -113,12 +229,12 @@ while [ $# != 0 ]; do
 # But the argument to egrep must be kept small, or many versions of egrep
 # won't be able to handle it.
 # rms: I removed `|#[el].*if.*[^/      ]' because it made egrep fail.
-    if egrep '[        _]_IO|CTRL|#define.NULL|#[el]*if.*([0-9]|sparc|vax|sun|pyr)' $file > /dev/null; then
-      echo Fixing $file
+    if egrep '//|[     _]_IO|CTRL|#define.NULL|#[el]*if.*([0-9]|sparc|vax|sun|pyr)' $file > /dev/null; then
       if [ -r $file ]; then
        cp $file $2/$file >/dev/null 2>&1       \
        || echo "Can't copy $file"
        chmod +w $2/$file
+       chmod a+r $2/$file
 # Following two lines removed.
 #        s%^\([        ]*#[    ]*endif[        ]*\)\([^/       ].*\)$%\1/* \2 */%
 #        s%^\([        ]*#[    ]*else[         ]*\)\([^/       ].*\)$%\1/* \2 */%
@@ -127,17 +243,18 @@ while [ $# != 0 ]; do
                                   :loop
          /\\$/                 N
          /\\$/                 b loop
+         /\/\/[^*]/                    s|//\(.*\)$|/*\1*/|
          /[    ]_IO[A-Z]*[     ]*(/    s/(\(.\),/('\''\1'\'',/
          /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
-         /#define._IO/         s/'\''x'\''/x/g
+         /#define._IO/                 s/'\''x'\''/x/g
          /#define.BSD43__IO/           s/'\''x'\''/x/g
-         /[^A-Z]CTRL[  ]*(/    s/\([^'\'']\))/'\''\1'\'')/
+         /[^A-Z]CTRL[  ]*(/            s/\([^'\'']\))/'\''\1'\'')/
          /#define.CTRL/                s/'\''c'\''/c/g
          /#define._CTRL/               s/'\''c'\''/c/g
          /#define.BSD43_CTRL/          s/'\''c'\''/c/g
-         /#[a-z]*if.*[  (]m68k/                s/\([^_]\)m68k/\1__m68k__/g
+         /#[a-z]*if.*[  (]m68k/        s/\([^_]\)m68k/\1__m68k__/g
          /#[a-z]*if.*[  (]__i386/      s/__i386/__i386__/g
-         /#[a-z]*if.*[  (]i386/                s/\([^_]\)i386/\1__i386__/g
+         /#[a-z]*if.*[  (]i386/        s/\([^_]\)i386/\1__i386__/g
          /#[a-z]*if.*[  (]sparc/       s/\([^_]\)sparc/\1__sparc__/g
          /#[a-z]*if.*[  (]mc68000/     s/\([^_]\)mc68000/\1__mc68000__/g
          /#[a-z]*if.*[  (]vax/         s/\([^_]\)vax/\1__vax__/g
@@ -146,13 +263,14 @@ while [ $# != 0 ]; do
          /#[a-z]*if.*[  (]ns32000/     s/\([^_]\)ns32000/\1__ns32000__/g
          /#[a-z]*if.*[  (]pyr/         s/\([^_]\)pyr/\1__pyr__/g
          /#[a-z]*if.*[  (]is68k/       s/\([^_]\)is68k/\1__is68k__/g
-         /#define.NULL[        ]/      i\
+         /^#define.NULL[       ]/      i\
                #undef NULL
        ' $2/$file > $2/$file.sed
        mv $2/$file.sed $2/$file
        if cmp $file $2/$file >/dev/null 2>&1; then
-          echo Deleting $2/$file\; no fixes were needed.
           rm $2/$file
+       else
+          echo Fixed $file
        fi
       fi
     fi
@@ -168,16 +286,44 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/sundev 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file comment
-  ex ${LIB}/$file <<EOF
-  g/doesn't/s/doesn't/does not/
-  wq
-EOF
+  sed -e "s/doesn't/does not/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+
+# Fix these Sun OS files to avoid an invalid identifier in an #ifdef.
+file=sunwindow/win_cursor.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+#  mkdir ${LIB}/sunwindow 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file
+  sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+file=sunwindow/win_lock.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+#  mkdir ${LIB}/sunwindow 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file
+  sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -187,69 +333,69 @@ file=sys/stdtypes.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
-  ex ${LIB}/$file <<EOF
-  /size_t.*;/
-  i
-#ifndef _GCC_SIZE_T
-#define _GCC_SIZE_T
-.
-  /size_t/+1
-  i
-#endif
-.
-  /ptrdiff_t.*;/
-  i
-#ifndef _GCC_PTRDIFF_T
-#define _GCC_PTRDIFF_T
-.
-  /ptrdiff_t/+1
-  i
-#endif
-.
-  /wchar_t.*;/
-  i
-#ifndef _GCC_WCHAR_T
-#define _GCC_WCHAR_T
-.
-  /wchar_t/+1
-  i
-#endif
-.
-  wq
-EOF
+sed -e '/size_t.*;/i\
+#ifndef _GCC_SIZE_T\
+#define _GCC_SIZE_T' \
+    -e '/size_t.*;/a\
+#endif' \
+    -e '/ptrdiff_t.*;/i\
+#ifndef _GCC_PTRDIFF_T\
+#define _GCC_PTRDIFF_T' \
+    -e '/ptrdiff_t.*;/a\
+#endif' \
+    -e '/wchar_t.*;/i\
+#ifndef _GCC_WCHAR_T\
+#define _GCC_WCHAR_T' \
+    -e '/wchar_t.*;/a\
+#endif' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
 
-# Fix this file to avoid interfering with stddef.h.
+# Fix this file to avoid interfering with stddef.h, but don't mistakenly
+# match e.g. ssize_t present in AIX for the ps/2.
 file=sys/types.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
-  ex ${LIB}/$file <<EOF
-  /size_t.*;/
-  i
-#ifndef _GCC_SIZE_T
-#define _GCC_SIZE_T
-.
-  /size_t/+1
-  i
-#endif
-.
-  wq
-EOF
+sed -e '/size_t.*;/i\
+#ifndef _GCC_SIZE_T\
+#define _GCC_SIZE_T' \
+    -e '/size_t.*;/a\
+#endif' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+
+# Fix an error in this file: the #if says _cplusplus, not the double
+# underscore __cplusplus that it should be
+file=tinfo.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  mkdir ${LIB}/rpcsvc 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, __cplusplus macro
+  sed -e 's/[  ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -261,16 +407,14 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/rpcsvc 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, definition of statsswtch
-  ex ${LIB}/$file <<EOF
-  g/boottime$/s//&;/
-  wq
-EOF
+  sed -e 's/boottime$/boottime;/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -282,16 +426,14 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/netdnet 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, definition of nodeent
-  ex ${LIB}/$file <<EOF
-  g/na_addr/s//&;/
-  wq
-EOF
+  sed -e 's/char.*na_addr *$/char *na_addr;/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -301,17 +443,14 @@ file=sys/file.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, bad \#ifdef line
-  ex ${LIB}/$file <<EOF
-  g/^#ifdef KERNEL && !defined/
-  s/#ifdef KERNEL && !defined/#if defined(KERNEL) \&\& !defined/
-  wq
-EOF
+  sed -e 's/#ifdef KERNEL/#if defined(KERNEL)/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -322,6 +461,7 @@ fi
 #if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
 #  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
 #  chmod +w ${LIB}/$file 2>/dev/null
+#  chmod a+r ${LIB}/$file 2>/dev/null
 #fi
 #
 #if [ -r ${LIB}/$file ]; then
@@ -329,7 +469,6 @@ fi
 #  sed -e 's/#endif.*/#endif/' ${LIB}/$file > ${LIB}/${file}.sed
 #  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
 #  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-#    echo Deleting ${LIB}/$file\; no fixes were needed.
 #    rm -f ${LIB}/$file
 #  fi
 #fi
@@ -340,17 +479,14 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/machine 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file, superfluous static
-  ex ${LIB}/$file <<EOF
-  g/^static struct tlb_pid_state/
-  s/static//
-  wq
-EOF
+  sed -e 's/^static struct tlb_pid_state/struct tlb_pid_state/' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   else
 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
@@ -367,20 +503,37 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/X11 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file sprintf declaration
-  ex ${LIB}/$file <<EOF
-  /^extern char \*     sprintf();$/c
-#ifndef __STDC__
-extern char *  sprintf();
-#endif /* !defined __STDC__ */
-.
-  wq
-EOF
+  sed -e 's,^extern char \*    sprintf();$,#ifndef __STDC__\
+extern char *  sprintf();\
+#endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm ${LIB}/$file
+  fi
+fi
+
+# Incorrect sprintf declaration in X11/Xmu/Xmu.h
+# (It's not clear whether the right file name is this or X11/Xmu.h.)
+file=X11/Xmu/Xmu.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  mkdir ${LIB}/X11/Xmu 2>/dev/null
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file sprintf declaration
+  sed -e 's,^extern char \*    sprintf();$,#ifndef __STDC__\
+extern char *  sprintf();\
+#endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm ${LIB}/$file
   fi
 fi
@@ -391,6 +544,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/netinet 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -398,7 +552,6 @@ if [ -r ${LIB}/$file ]; then
   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -409,6 +562,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/pixrect 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -422,7 +576,6 @@ if [ -r ${LIB}/$file ]; then
 ' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -433,6 +586,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/rpcsvc 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -440,7 +594,6 @@ if [ -r ${LIB}/$file ]; then
   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -450,6 +603,7 @@ file=stdlib.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -462,7 +616,6 @@ if [ -r ${LIB}/$file ]; then
   -e 's/int    exit/void       exit/g' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -472,15 +625,16 @@ file=malloc.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
   echo Fixing $file
-  sed -e 's/typedef char \*    malloc_t/typedef void \*        malloc_t/g' \
+  sed -e 's/typedef[   ]char \*        malloc_t/typedef void \*        malloc_t/g' \
+  -e 's/int[   ][      ]*free/void     free/g' \
   ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -491,6 +645,7 @@ file=locale.h
 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -498,7 +653,6 @@ if [ -r ${LIB}/$file ]; then
   sed -e 's%#endif / \*%#endif /\* %g' ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -509,6 +663,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -517,7 +672,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -528,6 +682,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -536,7 +691,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -547,6 +701,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/hsfs 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -555,7 +710,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -566,6 +720,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/machine 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -574,7 +729,6 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
-    echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
@@ -585,6 +739,7 @@ if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
   mkdir ${LIB}/sys 2>/dev/null
   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
   chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
 fi
 
 if [ -r ${LIB}/$file ]; then
@@ -594,11 +749,201 @@ if [ -r ${LIB}/$file ]; then
     ${LIB}/$file > ${LIB}/${file}.sed
   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# Fix non-ANSI memcpy declaration that conflicts with gcc's builtin
+# declaration on Sun OS 4.x.  We must only fix this on Sun OS 4.x, because
+# many other systems have similar text but correct versions of the file.
+# To ensure only Sun's is fixed, we grep for a likely unique string.
+file=memory.h
+if egrep '/\*  @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
+  if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+    cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+    chmod +w ${LIB}/$file 2>/dev/null
+    chmod a+r ${LIB}/$file 2>/dev/null
+  fi
+  if [ -r ${LIB}/$file ]; then
+    echo Replacing $file
+    cat > ${LIB}/$file << EOF
+/* This file was generated by fixincludes */
+#ifndef __memory_h__
+#define __memory_h__
+
+#ifdef __STDC__
+extern void *memccpy();
+extern void *memchr();
+extern void *memcpy();
+extern void *memset();
+#else
+extern char *memccpy();
+extern char *memchr();
+extern char *memcpy();
+extern char *memset();
+#endif /* __STDC__ */
+
+extern int memcmp();
+
+#endif __memory_h__
+EOF
+  fi
+fi
+
+# parameters not const on DECstation Ultrix V4.0.
+file=stdio.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, non-const arg
+  sed -e 's@perror( char \*__s );@perror( const char *__s );@' \
+      -e 's@fputs( char \*__s,@fputs( const char *__s,@' \
+      -e 's@fopen( char \*__filename, char \*__type );@fopen( const char *__filename, const char *__type );@' \
+      -e 's@fwrite( void \*__ptr,@fwrite( const void *__ptr,@' \
+      -e 's@fscanf( FILE \*__stream, char \*__format,@fscanf( FILE *__stream, const char *__format,@' \
+      -e 's@scanf( char \*__format,@scanf( const char *__format,@' \
+      -e 's@sscanf( char \*__s, char \*__format,@sscanf( const char *__s, const char *__format,@' \
+    ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# parameters conflict with C++ new on rs/6000 
+file=stdio.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, parameter name conflicts
+  sed -e 's@rename(const char \*old, const char \*new)@rename(const char *_old, const char *_new)@' \
+    ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# Don't use or define the name va_list in stdio.h.
+# This is for ANSI and also to interoperate properly with gvarargs.h.
+file=stdio.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, use of va_list
+  # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
+  (echo "#define __need___va_list"
+   echo "#include <stdarg.h>") > ${LIB}/${file}.sed
+  # Use __gnuc_va_list in arg types in place of va_list.
+  # Define __va_list__ (something harmless and unused) instead of va_list.
+  # Don't claim to have defined va_list.
+  sed -e 's@ va_list @ __gnuc_va_list @' \
+      -e 's@ va_list@ __va_list__@' \
+      -e 's@\*va_list@*__va_list__@' \
+      -e 's@VA_LIST@DUMMY_VA_LIST@' \
+    ${LIB}/$file >> ${LIB}/${file}.sed
+  
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# Cancel out ansi_compat.h on Ultrix.  Replace it with empty file.
+file=ansi_compat.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  if grep -s ULTRIX $file; then
+    echo "/* This file intentionally left blank.  */" > $LIB/$file
+  fi
+fi
+
+# parameter to atof not const on DECstation Ultrix V4.0.
+# also get rid of bogus inline definitions in HP-UX 8.0
+file=math.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file, non-const arg
+  sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
+      -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
+      -e 's@inline double abs(double d) { return fabs(d); }@@' \
+    ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
+    rm -f ${LIB}/$file
+  fi
+fi
+
+# In limits.h, put #ifndefs around things that are supposed to be defined
+# in float.h to avoid redefinition errors if float.h is included first.
+file=limits.h
+if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
+  cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
+  chmod +w ${LIB}/$file 2>/dev/null
+  chmod a+r ${LIB}/$file 2>/dev/null
+fi
+
+if [ -r ${LIB}/$file ]; then
+  echo Fixing $file
+  sed -e '/[   ]FLT_MIN[       ]/i\
+#ifndef FLT_MIN'\
+      -e '/[   ]FLT_MIN[       ]/a\
+#endif'\
+      -e '/[   ]FLT_MAX[       ]/i\
+#ifndef FLT_MAX'\
+      -e '/[   ]FLT_MAX[       ]/a\
+#endif'\
+      -e '/[   ]FLT_DIG[       ]/i\
+#ifndef FLT_DIG'\
+      -e '/[   ]FLT_DIG[       ]/a\
+#endif'\
+      -e '/[   ]DBL_MIN[       ]/i\
+#ifndef DBL_MIN'\
+      -e '/[   ]DBL_MIN[       ]/a\
+#endif'\
+      -e '/[   ]DBL_MAX[       ]/i\
+#ifndef DBL_MAX'\
+      -e '/[   ]DBL_MAX[       ]/a\
+#endif'\
+      -e '/[   ]DBL_DIG[       ]/i\
+#ifndef DBL_DIG'\
+      -e '/[   ]DBL_DIG[       ]/a\
+#endif'\
+    ${LIB}/$file > ${LIB}/${file}.sed
+  rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
+  if cmp $file ${LIB}/$file >/dev/null 2>&1; then
     echo Deleting ${LIB}/$file\; no fixes were needed.
     rm -f ${LIB}/$file
   fi
 fi
 
+# These two files on SunOS 4 are included by other files
+# in the same directory, using "...".  So we must make sure they exist
+# in the same directory as the other fixed files.
+if [ -r ${INPUT}/multimedia/audio_errno.h ]
+then
+  ln -s ${INPUT}/multimedia/audio_errno.h ${LIB}/multimedia 2>/dev/null
+fi
+if [ -r ${INPUT}/multimedia/audio_hdr.h ]
+then
+  ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
+fi
+
 echo 'Removing unneeded directories:'
 cd $LIB
 files=`find . -type d -print | sort -r`